to_grade_table = [
    (98,4),
    (96.5,3.9),
    (95,3.8),
    (93.5,3.7),
    (92,3.6),
    (90.5,3.5),
    (89,3.4),
    (87.5,3.3),
    (86,3.2),
    (84.5,3.1),
    (83,3.0),
    (81.5,2.9),
    (80,2.8),
    (78.5,2.7),
    (77,2.6),
    (75.5,2.5),
    (74,2.4),
    (72.5,2.3),
    (71,2.2),
    (69.5,2.1),
    (68,2.0),
    (66.5,1.9),
    (65,1.8),
    (63.5,1.7),
    (62,1.6),
    (60.5,1.5),
    (59,1.4),
    (57.5,1.3),
    (56,1.2),
    (54.5,1.1),
    (53.0,1.0),
    (51.5,0.9),
    (50.1,0.8),
    (50.0,0.7),
    (0,0)]

def percent_to_grade(p):
    for x, g in to_grade_table:
        if p >= x:
            return g
    raise RuntimeError



def C(x):
    if '.' in x:
        return RR(x)
    if x:
        return ZZ(x)
    else:
        return 0
    
class Student:
    def __init__(self, x):
        self.x = x
        v = x.split('\t')
        self.name = v[0]
        self.hw = [C(v[i])/C(max_points[i]) for i in range(len(v)) if headings[i].startswith('HW')]
        self.final = C(v[-1])/C(max_points[-1])
        hw_grade = (sum(self.hw) - min(self.hw))/float(len(self.hw)-1)
        grade = .6 * hw_grade + .4 * self.final
        self.grade = percent_to_grade(grade * 100)
        
    def __repr__(self):
        return '%s %s %.3f [[%.3f]]'%(self.name, ' '.join(str(h) for h in self.hw), self.final, self.grade)

Z = open('gradesheet.txt').read().split('\r')
max_points = Z[1].split('\t')
headings = Z[0].split('\t')
students = [Student(x) for x in Z[2:] if x]

for X in students:
    print X


